{ 
 Module.scm
 this provides support for jscheme macros which have the form
 (module MODULENAME 
    (use file1 file2 ...)
    (use-exporting file3 file4 ...)    
    (export var1 var2 ...)
     BODY)
 loading a modules stores an association list 

 (module test (uses ) (exports f) (define (a x) (* x x)) (define (f x) (a (a x))))
 (requires test)
}

(define _JSCHEME_MODULES_HASHTABLE_ (java.util.Hashtable.))

(define (show-modules) _JSCHEME_MODULES_HASHTABLE_)

(define (reset-modules)
  (set! _JSCHEME_MODULES_HASHTABLE_ (java.util.Hashtable.)))

(define-macro (requires modname)
  (if (equal? #null (.get _JSCHEME_MODULES_HASHTABLE_ modname)) (load modname))
  (if (equal? #null (.get _JSCHEME_MODULES_HASHTABLE_ modname))
       (.put _JSCHEME_MODULES_HASHTABLE_ modname ()))
  (cons 'begin  
    (map 
     (lambda(x) `(define ,(first x) ,(second x))) 
     (.get _JSCHEME_MODULES_HASHTABLE_ modname))))


(define-macro (module modname uses uses-and-exports exports . body)
  (define (load-uses Is)
    (for-each (lambda (x) (if (equal? #null (.get _JSCHEME_MODULES_HASHTABLE_ x)) (load x))) Is))
  (define (get-uses Is)
    (map (lambda(x) `(,(first x)  ',(second x))) Is))
  (define (make-exports Es)
     (cons 'list  (map (lambda(x) `(list ',x ,x)) Es)))
  (load-uses (rest uses))
  (load-uses (rest uses-and-exports))
  (let ((mac
  `(begin
     (let
       ,(get-uses (apply append (map (lambda(x) (.get _JSCHEME_MODULES_HASHTABLE_ x)) 
               (append (rest uses) (rest uses-and-exports)))))
       ,@body
       (.put _JSCHEME_MODULES_HASHTABLE_ ',modname 
           (append ,(make-exports (rest exports)) 
		   (apply append
			  (map (lambda(modname) 
				 (.get _JSCHEME_MODULES_HASHTABLE_ modname))
			       ',(rest uses-and-exports)))))))))
      (display mac)(newline)(newline)
      mac))


